# TMatrix33Template< T > Class Template Reference
[Math classes]

Inheritance diagram for TMatrix33Template< T >:

List of all members.

## Public Member Functions
| TMatrix33Template (void)
template<class U >
| TMatrix33Template (const TMatrix33Template< U > &original)
| TMatrix33Template (const T &m00, const T &m01, const T &m02, const T &m10, const T &m11, const T &m12, const T &m20, const T &m21, const T &m22)
uint32 | GetRowDimension (void) const
uint32 | GetColumnDimension (void) const
T | operator() (const uint32 row, const uint32 col) const
T & | operator() (const uint32 row, const uint32 col)
const T * | operator[] (const uint32 row) const
T * | operator[] (const uint32 row)
void | GetRow (const uint32 row, TVector3Template< T > &v) const
void | SetRow (const uint32 row, const TVector3Template< T > &v)
void | GetColumn (const uint32 col, TVector3Template< T > &v) const
void | SetColumn (const uint32 col, const TVector3Template< T > &v)
void | SetToTranspose (void)
void | SetToTransposeOf (const TMatrix33Template< T > &source)
TMatrix33Template< T > | GetTranspose (void) const
TMatrix33Template< T > | GetAdjoint () const
TMatrix33Template< T > | GetOrthonormal (boolean *success, int32 keepAxis=0) const
TMatrix33Template< T > | GetOrthgonalize (boolean *success, int32 keepAxis=0) const
boolean | IsOrthogonal () const
void | Triangulate (TMatrix33Template< T > &orthoL, TMatrix33Template< T > &orthoR)
T | GetTrace (void) const
T | GetDeterminant (void) const
T | GetNorm2 (void) const
void | Multiply (const TMatrix33Template< T > &m, const TMatrix33Template< T > &n)
TMatrix33Template< T > & | operator*= (const T &scalar)
template<class U >
TMatrix33Template< T > & | operator= (const TMatrix33Template< U > &original)
TMatrix33Template< T > & | operator= (const int32 i)
TMatrix33Template< T > & | operator+= (const TMatrix33Template< T > &m)
TMatrix33Template< T > & | operator-= (const TMatrix33Template< T > &m)
TMatrix33Template< T > | operator+ (const TMatrix33Template< T > &r) const
TMatrix33Template< T > | operator- (const TMatrix33Template< T > &r) const
TMatrix33Template< T > | operator* (const TMatrix33Template< T > &r) const
TMatrix33Template< T > | operator- () const
boolean | operator== (const TMatrix33Template< T > &rhs) const
boolean | operator!= (const TMatrix33Template< T > &rhs) const
void | SetColumns (const TVector3Template< T > &c0, const TVector3Template< T > &c1, const TVector3Template< T > &c2)
void | GetColumns (TVector3Template< T > &c0, TVector3Template< T > &c1, TVector3Template< T > &c2) const
void | SetToDiagonalTfm (const T &x, const T &y, const T &z)
void | SetPhyThetaPsy (const T &phy, const T &theta, const T &psy, boolean isDirect)
void | GetPhyThetaPsy (T &phy, T &theta, T &psy, boolean &isDirect) const
boolean | IsEqual (const TMatrix33Template< T > &rhs, const T &zeroTolerance=0.0) const
boolean | IsEqualRelative (const TMatrix33Template< T > &rhs, const T &zeroTolerance=0.0) const
void | SetIJK (const TVector3Template< T > &c0, const TVector3Template< T > &c1, const TVector3Template< T > &c2)
void | GetIJK (TVector3Template< T > &c0, TVector3Template< T > &c1, TVector3Template< T > &c2) const
void | SetDiagonal (const T &x, const T &y, const T &z)
void | Reset ()
boolean | IsIdentity () const
TMatrix33Template< T > | Transpose () const
TMatrix33Template< T > | Inverse (boolean *success) const
## Static Public Attributes
static const TMatrix33Template< T > | kIdentity
static const TMatrix33Template< T > | kZero
## Protected Attributes
T | value [3][3]
| Stores the coeficients of the matrix in the form value[row][col].

## Detailed Description

### template<class T>
class TMatrix33Template< T >

Stores a 3 by 3 matrix and implements basic matrix operations. The matrix coeficients are stored in the value field

## Constructor & Destructor Documentation

template<class T >

TMatrix33Template< T >::TMatrix33Template | ( | void |  | ) | `[inline]`

template<class T>
template<class U >

TMatrix33Template< T >::TMatrix33Template | ( | const TMatrix33Template< U > & | original | ) | `[inline]`

template<class T>

TMatrix33Template< T >::TMatrix33Template | ( | const T & | m00,
|  | const T & | m01,
|  | const T & | m02,
|  | const T & | m10,
|  | const T & | m11,
|  | const T & | m12,
|  | const T & | m20,
|  | const T & | m21,
|  | const T & | m22 |
| ) |  |  | `[inline]`

## Member Function Documentation

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::GetAdjoint | ( |  | ) | const

template<class T>

void TMatrix33Template< T >::GetColumn | ( | const uint32 | col,
|  | TVector3Template< T > & | v |
| ) |  |  | const

template<class T >

uint32 TMatrix33Template< T >::GetColumnDimension | ( | void |  | ) | const`[inline]`

template<class T>

void TMatrix33Template< T >::GetColumns | ( | TVector3Template< T > & | c0,
|  | TVector3Template< T > & | c1,
|  | TVector3Template< T > & | c2 |
| ) |  |  | const

template<class T>

T TMatrix33Template< T >::GetDeterminant | ( | void |  | ) | const

template<class T>

void TMatrix33Template< T >::GetIJK | ( | TVector3Template< T > & | c0,
|  | TVector3Template< T > & | c1,
|  | TVector3Template< T > & | c2 |
| ) |  |  | const`[inline]`

template<class T>

T TMatrix33Template< T >::GetNorm2 | ( | void |  | ) | const

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::GetOrthgonalize | ( | boolean * | success,
|  | int32 | keepAxis = `0` |
| ) |  |  | const

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::GetOrthonormal | ( | boolean * | success,
|  | int32 | keepAxis = `0` |
| ) |  |  | const

template<class T>

void TMatrix33Template< T >::GetPhyThetaPsy | ( | T & | phy,
|  | T & | theta,
|  | T & | psy,
|  | boolean & | isDirect |
| ) |  |  | const

template<class T>

void TMatrix33Template< T >::GetRow | ( | const uint32 | row,
|  | TVector3Template< T > & | v |
| ) |  |  | const

template<class T >

uint32 TMatrix33Template< T >::GetRowDimension | ( | void |  | ) | const`[inline]`

template<class T>

T TMatrix33Template< T >::GetTrace | ( | void |  | ) | const

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::GetTranspose | ( | void |  | ) | const

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::Inverse | ( | boolean * | success | ) | const

template<class T>

boolean TMatrix33Template< T >::IsEqual | ( | const TMatrix33Template< T > & | rhs,
|  | const T & | zeroTolerance = `0.0` |
| ) |  |  | const

template<class T>

boolean TMatrix33Template< T >::IsEqualRelative | ( | const TMatrix33Template< T > & | rhs,
|  | const T & | zeroTolerance = `0.0` |
| ) |  |  | const

template<class T>

boolean TMatrix33Template< T >::IsIdentity | ( |  | ) | const`[inline]`

template<class T>

boolean TMatrix33Template< T >::IsOrthogonal | ( |  | ) | const

template<class T>

void TMatrix33Template< T >::Multiply | ( | const TMatrix33Template< T > & | m,
|  | const TMatrix33Template< T > & | n |
| ) |  |  |

template<class T>

boolean TMatrix33Template< T >::operator!= | ( | const TMatrix33Template< T > & | rhs | ) | const`[inline]`

template<class T >

T & TMatrix33Template< T >::operator() | ( | const uint32 | row,
|  | const uint32 | col |
| ) |  |  | `[inline]`

template<class T >

T TMatrix33Template< T >::operator() | ( | const uint32 | row,
|  | const uint32 | col |
| ) |  |  | const`[inline]`

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::operator* | ( | const TMatrix33Template< T > & | r | ) | const

template<class T>

TMatrix33Template<T>& TMatrix33Template< T >::operator*= | ( | const T & | scalar | ) |

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::operator+ | ( | const TMatrix33Template< T > & | r | ) | const

template<class T>

TMatrix33Template<T>& TMatrix33Template< T >::operator+= | ( | const TMatrix33Template< T > & | m | ) |

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::operator- | ( |  | ) | const`[inline]`

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::operator- | ( | const TMatrix33Template< T > & | r | ) | const

template<class T>

TMatrix33Template<T>& TMatrix33Template< T >::operator-= | ( | const TMatrix33Template< T > & | m | ) |

template<class T >

TMatrix33Template< T > & TMatrix33Template< T >::operator= | ( | const int32 | i | ) | `[inline]`

template<class T>
template<class U >

TMatrix33Template<T>& TMatrix33Template< T >::operator= | ( | const TMatrix33Template< U > & | original | ) | `[inline]`

template<class T>

boolean TMatrix33Template< T >::operator== | ( | const TMatrix33Template< T > & | rhs | ) | const`[inline]`

template<class T >

T * TMatrix33Template< T >::operator[] | ( | const uint32 | row | ) | `[inline]`

template<class T >

const T * TMatrix33Template< T >::operator[] | ( | const uint32 | row | ) | const`[inline]`

template<class T>

void TMatrix33Template< T >::Reset | ( |  | ) | `[inline]`

template<class T>

void TMatrix33Template< T >::SetColumn | ( | const uint32 | col,
|  | const TVector3Template< T > & | v |
| ) |  |  |

template<class T>

void TMatrix33Template< T >::SetColumns | ( | const TVector3Template< T > & | c0,
|  | const TVector3Template< T > & | c1,
|  | const TVector3Template< T > & | c2 |
| ) |  |  |

template<class T>

void TMatrix33Template< T >::SetDiagonal | ( | const T & | x,
|  | const T & | y,
|  | const T & | z |
| ) |  |  | `[inline]`

template<class T>

void TMatrix33Template< T >::SetIJK | ( | const TVector3Template< T > & | c0,
|  | const TVector3Template< T > & | c1,
|  | const TVector3Template< T > & | c2 |
| ) |  |  | `[inline]`

template<class T>

void TMatrix33Template< T >::SetPhyThetaPsy | ( | const T & | phy,
|  | const T & | theta,
|  | const T & | psy,
|  | boolean | isDirect |
| ) |  |  |

template<class T>

void TMatrix33Template< T >::SetRow | ( | const uint32 | row,
|  | const TVector3Template< T > & | v |
| ) |  |  |

template<class T>

void TMatrix33Template< T >::SetToDiagonalTfm | ( | const T & | x,
|  | const T & | y,
|  | const T & | z |
| ) |  |  |

template<class T>

void TMatrix33Template< T >::SetToTranspose | ( | void |  | ) |

template<class T>

void TMatrix33Template< T >::SetToTransposeOf | ( | const TMatrix33Template< T > & | source | ) |

template<class T>

TMatrix33Template<T> TMatrix33Template< T >::Transpose | ( |  | ) | const`[inline]`

template<class T>

void TMatrix33Template< T >::Triangulate | ( | TMatrix33Template< T > & | orthoL,
|  | TMatrix33Template< T > & | orthoR |
| ) |  |  |

## Member Data Documentation

template<class T>

const TMatrix33Template<T> TMatrix33Template< T >::kIdentity`[static]`

template<class T>

const TMatrix33Template<T> TMatrix33Template< T >::kZero`[static]`

template<class T>

T TMatrix33Template< T >::value[3][3]`[protected]`

Stores the coeficients of the matrix in the form value[row][col].

The documentation for this class was generated from the following file:

- Matrix33.h